"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/asyncToGenerator"));

var _core = _interopRequireDefault(require("@arice/core"));

var _xajs = require("xajs");

var _constants = require("./constants");

var bootstrap = function bootstrap(_ref) {
  var _ref$framework = _ref.framework,
      framework = _ref$framework === void 0 ? {} : _ref$framework,
      _ref$apps = _ref.apps,
      apps = _ref$apps === void 0 ? {} : _ref$apps,
      _ref$viewEngine = _ref.viewEngine,
      viewEngine = _ref$viewEngine === void 0 ? {} : _ref$viewEngine,
      _ref$plugins = _ref.plugins,
      plugins = _ref$plugins === void 0 ? [] : _ref$plugins,
      _ref$beforeBootstrap = _ref.beforeBootstrap,
      beforeBootstrap = _ref$beforeBootstrap === void 0 ? _constants.NOOP : _ref$beforeBootstrap,
      _ref$afterBootstrap = _ref.afterBootstrap,
      afterBootstrap = _ref$afterBootstrap === void 0 ? _constants.NOOP : _ref$afterBootstrap;
  return (
    /*#__PURE__*/
    function () {
      var _ref2 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee(appName) {
        var rf, bb, ab, k, ve, _apps$appName, bundlePromise, _apps$appName$options, options, _apps$appName$sideEff, sideEffects, _apps$appName$beforeB, _beforeBootstrap, _apps$appName$afterBo, _afterBootstrap, getBundle, app, _options$mountNode, mountNode, _options$props, props;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                rf = new _core["default"].Framework(framework);
                bb = beforeBootstrap, ab = afterBootstrap;
                _context.t0 = _regenerator["default"].keys(viewEngine);

              case 3:
                if ((_context.t1 = _context.t0()).done) {
                  _context.next = 11;
                  break;
                }

                k = _context.t1.value;
                ve = viewEngine[k];

                if (ve.isRiceView) {
                  _context.next = 8;
                  break;
                }

                throw new Error("viewEngine: ".concat(k, " is not a valid rice view engine."));

              case 8:
                rf.defineView(k, ve);
                _context.next = 3;
                break;

              case 11:
                if (!(appName in apps)) {
                  _context.next = 31;
                  break;
                }

                _apps$appName = apps[appName], bundlePromise = _apps$appName.bundle, _apps$appName$options = _apps$appName.options, options = _apps$appName$options === void 0 ? _constants.DEFAULT_APP_OPTIONS : _apps$appName$options, _apps$appName$sideEff = _apps$appName.sideEffects, sideEffects = _apps$appName$sideEff === void 0 ? _constants.NOOP : _apps$appName$sideEff, _apps$appName$beforeB = _apps$appName.beforeBootstrap, _beforeBootstrap = _apps$appName$beforeB === void 0 ? bb : _apps$appName$beforeB, _apps$appName$afterBo = _apps$appName.afterBootstrap, _afterBootstrap = _apps$appName$afterBo === void 0 ? ab : _apps$appName$afterBo;

                getBundle = function getBundle() {
                  return null;
                };

                if (_xajs.internal.is.isFunction(bundlePromise)) {
                  getBundle = function getBundle() {
                    return bundlePromise().then(function (mod) {
                      return mod["default"];
                    });
                  };
                }

                _context.next = 17;
                return getBundle();

              case 17:
                app = _context.sent;

                if (app) {
                  _context.next = 20;
                  break;
                }

                throw new Error("Bundle of [".concat(appName, "] load failed, please check."));

              case 20:
                _context.next = 22;
                return _beforeBootstrap(rf);

              case 22:
                _options$mountNode = options.mountNode, mountNode = _options$mountNode === void 0 ? null : _options$mountNode, _options$props = options.props, props = _options$props === void 0 ? {} : _options$props; // setup sideEffects

                _context.next = 25;
                return sideEffects(rf.$effectCenter.$effect);

              case 25:
                _context.next = 27;
                return rf.loadApp(app, mountNode, props, plugins);

              case 27:
                _context.next = 29;
                return _afterBootstrap(rf);

              case 29:
                _context.next = 32;
                break;

              case 31:
                throw new Error("Can not find this app: ".concat(appName, "."));

              case 32:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }()
  );
};

var _default = bootstrap;
exports["default"] = _default;